function [F,g]=general_fungrad(Y,pars)

% Computes 
% the length functional and its gradient.
%


n=pars.n;
n2=n*n;
N=length(Y)/n2+1;
Xa=pars.Xa;
Xb=pars.Xb;

D=Xb-Xa;

X=[Xa;Xb;ones(n2,1);Y];
% compute function to be integrated
K=10*N; % number of nodes for integration
f=zeros(K,1);
%g=zeros(K,1);
t=1/(K-1);  % time interval
gg=zeros(n2*(N-1),K);
for j=1:K
    auxX=(X(2*n2+1:3*n2)).*(Xa+(j-1)*t*D);  % linear component
    Xdot=(X(2*n2+1:3*n2)).*D;
    T=(j-1)*t;
    for i=1:N-1
        auxX=auxX+X((i+2)*n2+1:(i+3)*n2)*sin(i*pi*T);
        Xdot=Xdot+i*pi*X((i+2)*n2+1:(i+3)*n2)*cos(i*pi*T);
    end
    [u,ss,v]=svd(reshape(auxX,n,n));
    s=diag(ss);
    f(j)=norm(Xdot)/s(n);
    % let's compute the gradient
    aux=u(:,n)*v(:,n)';
    for i=1:N-1
    gg((i-1)*n2+1:i*n2,j)=Xdot*i*pi*cos(i*pi*T)/(norm(Xdot)*s(n))-norm(Xdot)*aux(:)*sin(i*pi*T)/(s(n)*s(n));
    end
end

% compute integral of f (naively for now)
F=0;
g=0;
for j=1:K-1
    F=F+t*(f(j+1)+f(j))/2;
    g=g+t*(gg(:,j+1)+gg(:,j))/2;
end